// bla.c for Windows & posix   by 썇G & kozossakai CZXKL-01.

#include "bla.h"

#define bla_TABLESIZ	16

static bla_Window *bla_table_w[bla_TABLESIZ];

// level0

int main(int argc, const char **argv)
{
	int i = bla_main(argc, argv);
	bla_exit(i);
	return i; /* for warning */
}

STATIC void bla_exit(int i)
{
	exit(i);
}

#if (!defined(KCONSONLY))

static WID_t bla_table_hw[bla_TABLESIZ];

static void putKeybuf(bla_Window *w, int c)
{
	if (((w->kbw + 1) & (bla_KEYBUFSIZ - 1)) != w->kbr) {
		w->keybuf[w->kbw] = c;
		w->kbw = (w->kbw + 1) & (bla_KEYBUFSIZ - 1);
	}
}

#endif

#if (defined(KESCTERM))

static void escTerm(bla_Window *w)
{
	int index, x, y, r, b, g, c, oldc = -1;
	static char *escstr[] = {
		"\x1b[30;40m", /* black */
		"\x1b[30;41m", /* red */
		"\x1b[30;42m", /* green */
		"\x1b[30;43m", /* yellow */
		"\x1b[30;44m", /* blue */
		"\x1b[30;45m", /* magenta */
		"\x1b[30;46m", /* cyan */
		"\x1b[30;47m", /* white */
	};
	fputs("\x1b[1;1H", stdout);
	for (y = 0; y < w->ysiz; y++) {
		for (x = 0; x < w->xsiz; x++) {
			c = w->buf[y * w->xsiz + (x + 1)];
			if ((c != oldc) || (!x && !y)) {
				r = ((c >> 16) & 0xff) >= 0x80;
				g = ((c >>  8) & 0xff) >= 0x80;
				b = ((c >>  0) & 0xff) >= 0x80;
				index = (b ? 4 : 0) | (g ? 2 : 0) | (r ? 1 : 0);
				fputs(escstr[index], stdout);
				oldc = c;
			}
			putchar(' ');
		}
		putchar('\n');
	}
	fputs("\x1b[0m", stdout);
}

#endif

#if (defined(KGDI32))

static LRESULT CALLBACK WndProc(HWND hw, UINT msg, WPARAM wp, LPARAM lp);

static int winthread(bla_Window *w)
{
	WNDCLASSEX wc;
	RECT r;
	int i, x, y;
	MSG msg;

	x = w->xsiz;
	y = w->ysiz;

	wc.cbSize = sizeof (WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = w->hInst;
	wc.hIcon = (HICON) LoadImage(NULL, MAKEINTRESOURCE(IDI_APPLICATION),
		IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hCursor = (HCURSOR)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW),
		IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);

	wc.hIconSm = wc.hIcon;
	wc.hbrBackground = (HBRUSH) COLOR_APPWORKSPACE;
	wc.lpszMenuName = 0;
	wc.lpszClassName = w->title;
	if (RegisterClassEx(&wc) == 0)
		return 1;
	r.left = 0;
	r.top = 0;
	r.right = x;
	r.bottom = y;
	AdjustWindowRect(&r, WS_OVERLAPPEDWINDOW, FALSE);
	x = r.right - r.left;
	y = r.bottom - r.top;

	w->hWnd = CreateWindowA(wc.lpszClassName, w->title, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, x, y, NULL, NULL,	w->hInst, NULL);
	if (w->hWnd == NULL)
		return 1;
	bla_table_hw[w->table_idx] = w->hWnd;
	ShowWindow(w->hWnd, SW_SHOW);
	UpdateWindow(w->hWnd);

	for (;;) {
		i = GetMessage(&msg, NULL, 0, 0);
		if (i == 0 || i == -1)	/* G[͏IbZ[W */
			break;
		/* ̂ق͂Ƃ肠ftHg */
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	// ̃^C~OfreeĂ͂Ȃ.
	UnregisterClass(w->title, w->hInst);
	w->phase = 2;
	return 0;
}

static int getKeyState0()
{
	int i = 0;
	if ((GetKeyState(VK_LSHIFT)   & (1 << 15)) != 0) i |= 1 << 16;
	if ((GetKeyState(VK_NUMLOCK)  & (1 <<  0)) != 0) i |= 1 << 22;
	if ((GetKeyState(VK_CAPITAL)  & (1 <<  0)) != 0) i |= 1 << 23;
	if ((GetKeyState(VK_RSHIFT)   & (1 << 15)) != 0) i |= 1 << 24;
	return i;	
}

static int getKeyState1()
{
	int j = 0;
	if ((GetKeyState(VK_LCONTROL) & (1 << 15)) != 0) j |= 1 << 17;
	if ((GetKeyState(VK_LMENU)    & (1 << 15)) != 0) j |= 1 << 18;
	if ((GetKeyState(VK_RCONTROL) & (1 << 15)) != 0) j |= 1 << 25;
	if ((GetKeyState(VK_RMENU)    & (1 << 15)) != 0) j |= 1 << 26;
	return j;	
}

static LRESULT CALLBACK WndProc(HWND hw, UINT msg, WPARAM wp, LPARAM lp)
{
	bla_Window *w;
	int i, j;
	for (i = 0; i < bla_TABLESIZ; i++) {
		if (bla_table_hw[i] == hw)
			break;
	}
	if (i >= bla_TABLESIZ)
		return DefWindowProc(hw, msg, wp, lp);
	w = bla_table_w[i];
	if (msg == WM_PAINT) {
		PAINTSTRUCT ps;
		HDC hdc = BeginPaint(hw, &ps);
		SetDIBitsToDevice(hdc, 0, 0, w->xsiz, w->ysiz,
			0, 0, 0, w->ysiz, w->buf, &w->bmi, DIB_RGB_COLORS);
		EndPaint(hw, &ps);
		return 0;
	}
	if (msg == WM_DESTROY) {
		PostQuitMessage(0); // ȂƃXbhIȂ.
		return 0;
	}
	if (msg == WM_KEYDOWN || msg == WM_SYSKEYDOWN) {
		i = -1;
		if (wp == VK_RETURN)	i = bla_KEY_ENTER;
		if (wp == VK_ESCAPE)	i = bla_KEY_ESC;
		if (wp == VK_BACK)		i = bla_KEY_BACKSPACE;
		if (wp == VK_TAB)		i = bla_KEY_TAB;
		if (wp == VK_PRIOR)		i = bla_KEY_PAGEUP;
		if (wp == VK_NEXT)		i = bla_KEY_PAGEDWN;
		if (wp == VK_END)		i = bla_KEY_END;
		if (wp == VK_HOME)		i = bla_KEY_HOME;
		if (wp == VK_LEFT)		i = bla_KEY_LEFT;
		if (wp == VK_RIGHT)		i = bla_KEY_RIGHT;
		if (wp == VK_UP)		i = bla_KEY_UP;
		if (wp == VK_DOWN)		i = bla_KEY_DOWN;
		if (wp == VK_INSERT)	i = bla_KEY_INS;
		if (wp == VK_DELETE)	i = bla_KEY_DEL;
		j = getKeyState1();
		if (j != 0 && ' ' <= wp && wp <= 0x7e)
			i = wp;	// CtrlAltƉĂꍇ́Aput.
		i |= getKeyState0();
		if (i != -1) {
			putKeybuf(w, i | j);
			return 0;
		}
	}
//	if (msg == WM_KEYUP) { i = 0xfff; }
	if (msg == WM_CHAR) {
		if (' ' <= wp && wp <= 0x7e) {
			i = wp | getKeyState0();
			j = getKeyState1();
			putKeybuf(w, i | j);
			return 0;
		}
	}
	if (msg == WM_CLOSE && w->autoClose == 0)
		return 0;
	return DefWindowProc(hw, msg, wp, lp);
}

STATIC void bla_flushAll(bla_Window *w)
{
	if (w->phase == 1) {
		InvalidateRect(w->hWnd, NULL, FALSE);
		UpdateWindow(w->hWnd);
		#if (defined(KESCTERM))
			escTerm(w);
		#endif
		w->lastFlush = clock();
	}
}

STATIC void bla_closeWin(bla_Window *w)
{
	if (w->phase == 1) {
		w->autoClose = 1;
		PostMessage(w->hWnd, WM_CLOSE, 0, 0);
		while (w->phase == 1)
			bla_wait(128);
	}
	free(w->buf);
	bla_table_w[w->table_idx] = 0;
	free(w);
}

#elif (defined(KSDL1) || defined(KSDL2) || defined(KSIXEL))

static int SDLProc(WID_t hw, SDL_Event *event);

static int sdlthread(void *p)
{
	bla_Window *w = (bla_Window *)p;
	SDL_Event e;
	int i, x, y;

#ifdef KSIXEL
	if (getenv("SDL_VIDEODRIVER") == NULL)
		setenv("SDL_VIDEODRIVER", "sixel", 0);
#endif

	SDL_Init(SDL_INIT_EVERYTHING);
#ifdef KSDL2
	SDL_SetThreadPriority(SDL_THREAD_PRIORITY_HIGH);
#endif
	x = w->xsiz;
	y = w->ysiz;

#ifdef KSDL2
	w->hWnd = SDL_CreateWindow(w->title,
				   SDL_WINDOWPOS_UNDEFINED,
				   SDL_WINDOWPOS_UNDEFINED,
				   x, y, 0);
#else
	SDL_SetVideoMode(x, y, 32, SDL_HWSURFACE);
	w->hWnd = (WID_t)w; /* dummy for select hw in SDLProc() */
#endif

	if (w->hWnd == NULL)
		return 1;
	bla_table_hw[w->table_idx] = w->hWnd;

#ifdef KSDL2
	w->renderer = SDL_CreateRenderer(w->hWnd, -1, SDL_RENDERER_ACCELERATED);
#else
	w->surface = SDL_GetVideoSurface();
#endif

	for (;;) {
		i = SDL_WaitEvent(&e);
		if (i < 1)
			break;
		if (SDLProc(w->hWnd, &e) < 0)
			break;
	}
#ifdef KSDL2
	SDL_DestroyRenderer(w->renderer);
	//SDL_Quit(); /* unneed? */
#else
	SDL_FreeSurface(w->surface);
	//SDL_Quit(); /* fail to execute OPENWIN and graphics... unneed? */
#endif

	w->phase = 2;
	return 0;
}

static int getKeyState0()
{
	int i = 0;
	const unsigned char *state;
#ifdef KSDL2
	state = SDL_GetKeyboardState(NULL);
	if (state[SDL_SCANCODE_LSHIFT])   i |= 1 << 16;
	//if (state[SDL_SCANCODE_NUMLOCK])  i |= 1 << 22;
	if (state[SDL_SCANCODE_CAPSLOCK]) i |= 1 << 23;
	if (state[SDL_SCANCODE_RSHIFT])   i |= 1 << 24;
#else
	state = SDL_GetKeyState(NULL);
	if (state[SDLK_LSHIFT])   i |= 1 << 16;
	//if (state[SDLK_NUMLOCK])  i |= 1 << 22;
	if (state[SDLK_CAPSLOCK]) i |= 1 << 23;
	if (state[SDLK_RSHIFT])   i |= 1 << 24;
#endif
	return i;	
}

static int getKeyState1()
{
	int j = 0;
	const unsigned char *state;
#ifdef KSDL2
	state = SDL_GetKeyboardState(NULL);
	if (state[SDL_SCANCODE_LCTRL]) j |= 1 << 17;
	if (state[SDL_SCANCODE_MENU])  j |= 1 << 18;
	if (state[SDL_SCANCODE_RCTRL]) j |= 1 << 25;
#else
	state = SDL_GetKeyState(NULL);
	if (state[SDLK_LCTRL]) j |= 1 << 17;
	if (state[SDLK_MENU])  j |= 1 << 18;
	if (state[SDLK_RCTRL]) j |= 1 << 25;
#endif
	return j;	
}

static int SDLProc(WID_t hw, SDL_Event *event)
{
	bla_Window *w;
	int i, j;
#ifdef KSDL2
	SDL_Keycode wp;
#else
	SDLKey wp;
#endif
	for (i = 0; i < bla_TABLESIZ; i++) {
		if (bla_table_hw[i] == hw)
			break;
	}
	if (i >= bla_TABLESIZ)
		return 0;
	w = bla_table_w[i];

#ifdef KSDL2
	if (event->type == SDL_WINDOWEVENT)
#else
	if (event->type == SDL_VIDEOEXPOSE)
#endif
	{
		int index, x, y, r, b, g;
		static struct {
			int count;
#define DRAW_POINTS_SIZE 128
			SDL_Rect point[DRAW_POINTS_SIZE];
		} points[7];

#ifdef KSDL2
		SDL_SetRenderDrawColor(w->renderer, 0, 0, 0, 0);
		SDL_RenderClear(w->renderer);
#else
		{
			SDL_Rect window_rect;
			window_rect.x = 0;
			window_rect.y = 0;
			window_rect.w = w->xsiz;
			window_rect.h = w->ysiz;
			SDL_FillRect(w->surface, &window_rect, SDL_MapRGB(w->surface->format, 0, 0, 0));
		}
#endif

		for (index = 0; index < 7; index++) {
			points[index].count = 0;
		}

		for (y = 0; y < w->ysiz; y++) {
			int oldx = 0, draw;
			int c, oldc = w->buf[y * w->xsiz];
			for (x = 0; x < w->xsiz; x++) {
				draw = 0;
				if (x < w->xsiz - 1) {
					c = w->buf[y * w->xsiz + (x + 1)];
					if (c != oldc)
						draw = 1;
				} else {
					c = -1; /* dummy value for warning */
					draw = 1;
				}
				if (!draw)
					continue;

				r = (oldc >> 16) & 0xff;
				g = (oldc >>  8) & 0xff;
				b = (oldc >>  0) & 0xff;

				if (!r && !b && !g) /* black */
					goto last;

				if (((r == 0) || (r == 255)) &&
				    ((g == 0) || (g == 255)) &&
				    ((b == 0) || (b == 255)) &&
				    ((x - oldx) > 0)) {
					index  = ((r == 255) ? 1 : 0) << 2;
					index |= ((g == 255) ? 1 : 0) << 1;
					index |= ((b == 255) ? 1 : 0) << 0;
					index--;

					if (points[index].count == DRAW_POINTS_SIZE) {
#ifdef KSDL2
						SDL_SetRenderDrawColor(w->renderer, r, g, b, 255);
						SDL_RenderDrawRects(w->renderer,
								    points[index].point,
								    points[index].count);
#else
						for (i = 0; i < points[index].count; i++) {
							SDL_FillRect(w->surface,
								     &points[index].point[i],
								     SDL_MapRGB(w->surface->format, r, g, b));
						}
#endif
						points[index].count = 0;
					}

					points[index].point[points[index].count].x = oldx;
					points[index].point[points[index].count].y = y;
					points[index].point[points[index].count].w = x - oldx + 1;
					points[index].point[points[index].count].h = 1;
					points[index].count++;
				} else {
#ifdef KSDL2
					SDL_SetRenderDrawColor(w->renderer, r, g, b, 255);
					if (oldx == x)
						SDL_RenderDrawPoint(w->renderer, x, y);
					else
						SDL_RenderDrawLine(w->renderer, oldx, y, x, y);
#else
					SDL_Rect rect;
					rect.x = x;
					rect.y = y;
					rect.w = x - oldx + 1;
					rect.h = 1;
					SDL_FillRect(w->surface,
					       &rect,
					       SDL_MapRGB(w->surface->format, r, g, b));
#endif
				}
last:
				oldc = c;
				oldx = x + 1;
			}
		}

		for (index = 0; index < 7; index++) {
			if (points[index].count == 0)
				continue;
			r = ((index + 1) & (1 << 2)) ? 255 : 0;
			g = ((index + 1) & (1 << 1)) ? 255 : 0;
			b = ((index + 1) & (1 << 0)) ? 255 : 0;
#ifdef KSDL2
			SDL_SetRenderDrawColor(w->renderer, r, g, b, 255);
			SDL_RenderDrawRects(w->renderer,
					    points[index].point,
					    points[index].count);
#else
			for (i = 0; i < points[index].count; i++) {
				SDL_FillRect(w->surface,
					     &points[index].point[i],
					     SDL_MapRGB(w->surface->format, r, g, b));
			}
#endif
		}

#ifdef KSDL2
		SDL_RenderPresent(w->renderer);
#else
		SDL_Flip(w->surface);
#endif

	}

	if (event->type == SDL_KEYDOWN) {
		i = -1;
#ifdef KSDL2
		SDL_Scancode scancode = ((SDL_KeyboardEvent *)event)->keysym.scancode;
		SDL_Keycode sym = ((SDL_KeyboardEvent *)event)->keysym.sym;

		if (scancode == SDL_SCANCODE_RETURN)	i = bla_KEY_ENTER;
		if (scancode == SDL_SCANCODE_ESCAPE)	i = bla_KEY_ESC;
		if (scancode == SDL_SCANCODE_BACKSPACE)	i = bla_KEY_BACKSPACE;
		if (scancode == SDL_SCANCODE_TAB)	i = bla_KEY_TAB;
		if (scancode == SDL_SCANCODE_PAGEUP)	i = bla_KEY_PAGEUP;
		if (scancode == SDL_SCANCODE_PAGEDOWN)	i = bla_KEY_PAGEDWN;
		if (scancode == SDL_SCANCODE_END)	i = bla_KEY_END;
		if (scancode == SDL_SCANCODE_HOME)	i = bla_KEY_HOME;
		if (scancode == SDL_SCANCODE_LEFT)	i = bla_KEY_LEFT;
		if (scancode == SDL_SCANCODE_RIGHT)	i = bla_KEY_RIGHT;
		if (scancode == SDL_SCANCODE_UP)	i = bla_KEY_UP;
		if (scancode == SDL_SCANCODE_DOWN)	i = bla_KEY_DOWN;
		if (scancode == SDL_SCANCODE_INSERT)	i = bla_KEY_INS;
		if (scancode == SDL_SCANCODE_DELETE)	i = bla_KEY_DEL;
#else
		SDLKey sym = ((SDL_KeyboardEvent *)event)->keysym.sym;

		if (sym == SDLK_RETURN)		i = bla_KEY_ENTER;
		if (sym == SDLK_ESCAPE)		i = bla_KEY_ESC;
		if (sym == SDLK_BACKSPACE)	i = bla_KEY_BACKSPACE;
		if (sym == SDLK_TAB)		i = bla_KEY_TAB;
		if (sym == SDLK_PAGEUP)		i = bla_KEY_PAGEUP;
		if (sym == SDLK_PAGEDOWN)	i = bla_KEY_PAGEDWN;
		if (sym == SDLK_END)		i = bla_KEY_END;
		if (sym == SDLK_HOME)		i = bla_KEY_HOME;
		if (sym == SDLK_LEFT)		i = bla_KEY_LEFT;
		if (sym == SDLK_RIGHT)		i = bla_KEY_RIGHT;
		if (sym == SDLK_UP)		i = bla_KEY_UP;
		if (sym == SDLK_DOWN)		i = bla_KEY_DOWN;
		if (sym == SDLK_INSERT)		i = bla_KEY_INS;
		if (sym == SDLK_DELETE)		i = bla_KEY_DEL;
#endif
		j = getKeyState1();
		wp = sym;
		if (j != 0 && ' ' <= wp && wp <= 0x7e)
			i = wp;	// CtrlAltƉĂꍇ́Aput.
		i |= getKeyState0();
		if (i != -1) {
			putKeybuf(w, i | j);
		}
	}

	if (event->type == SDL_KEYUP) {
#ifdef KSDL2
		SDL_Keycode sym = ((SDL_KeyboardEvent *)event)->keysym.sym;
#else
		SDLKey sym = ((SDL_KeyboardEvent *)event)->keysym.sym;
#endif
		wp = sym;
		if (' ' <= wp && wp <= 0x7e) {
			i = wp | getKeyState0();
			j = getKeyState1();
			putKeybuf(w, i | j);
		}
	}

	if (event->type == SDL_QUIT) {
		if (w->autoClose) {
#ifdef KSDL2
			SDL_DestroyWindow(w->hWnd);
#endif
			return -1;
		}
	}
	/* unknown event */
	return 0;
}

STATIC void bla_flushAll(bla_Window *w)
{
	if (w->phase == 1) {
		SDL_Event e;
		#if (defined(KESCTERM))
			escTerm(w);
		#endif

#ifdef KSDL2
		e.type = SDL_WINDOWEVENT;
#else
		e.type = SDL_VIDEOEXPOSE;
#endif
		SDL_PushEvent(&e);
		w->lastFlush = clock();
	}
}

STATIC void bla_closeWin(bla_Window *w)
{
	if (w->phase == 1) {
		w->autoClose = 1;
		SDL_Event e;
		int status;
		e.type = SDL_QUIT;
		SDL_PushEvent(&e);
		SDL_WaitThread(w->child, &status);
		while (w->phase == 1)
			bla_wait(128);
	}
	free(w->buf);
	bla_table_w[w->table_idx] = 0;
	free(w);
}

#elif (defined(KCONSONLY))

STATIC void bla_flushAll(bla_Window *w)
{
	if (w->phase == 1) {
		#if (defined(KESCTERM))
			escTerm(w);
		#endif
		w->lastFlush = clock();
	}
}

STATIC void bla_closeWin(bla_Window *w)
{
	free(w->buf);
	bla_table_w[w->table_idx] = 0;
	free(w);
}

#endif

#if (defined(KESCTERM) && defined(KWINDOWS))

STATIC void win_consinit()
{
	static int initialized = 0;
	if (initialized)
		return;

	HANDLE handle = (HANDLE)_get_osfhandle(_fileno(stdout));
	DWORD mode = 0;

	initialized = 1;

	if (!GetConsoleMode(handle, &mode)) {
		return;
	}
#ifndef ENABLE_VIRTUAL_TERMINAL_PROCESSING
#define ENABLE_VIRTUAL_TERMINAL_PROCESSING 0x0004
#endif
	if (!SetConsoleMode(handle, mode | ENABLE_VIRTUAL_TERMINAL_PROCESSING)) {
		return;
	}
}

#endif

STATIC bla_Window *bla_openWin(int x, int y, const char *t, int autoClose)
{
	int i;
	for (i = 0; i < bla_TABLESIZ; i++) {
		if (bla_table_w[i] == 0) break;
	}
	if (i >= bla_TABLESIZ) return 0;

	#if (defined(KESCTERM))
		win_consinit();
	#endif

	bla_Window *w = (bla_Window *) malloc(sizeof (bla_Window));
	bla_table_w[i] = w;
	w->table_idx = i;
	w->title[0] = '\0';
	if (t != 0) {
		strncpy(w->title, t, 63);
		w->title[63] = '\0';
	}
	if (w->title[0] == '\0') {
		w->title[0] = ' ';
		w->title[1] = '\0';
	}
	w->kbw = w->kbr = 0;
	w->phase = 1;
	w->xsiz = x;
	w->ysiz = y;
	w->buf = (int *) malloc(x * y * sizeof (int));
	w->lastFlush = clock();
	w->mode = bla_MODE_SET;
	w->autoClose = autoClose;
	memset(w->buf, 0, x * y * sizeof (int));

#if (defined(KGDI32))
	w->bmi.bmiHeader.biSize = sizeof (BITMAPINFOHEADER);
	w->bmi.bmiHeader.biWidth = x;
	w->bmi.bmiHeader.biHeight = - y;
	w->bmi.bmiHeader.biPlanes = 1;
	w->bmi.bmiHeader.biBitCount = 32;
	w->bmi.bmiHeader.biCompression = BI_RGB;
	CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) &winthread, (void *) w, 0, (LPDWORD) &i);
#elif (defined(KSDL1) || defined(KSIXEL))
	w->child = SDL_CreateThread(sdlthread, w);
#elif (defined(KSDL2))
	w->child = SDL_CreateThread(sdlthread, "child thread", w);
#endif
	return w;
}

STATIC void bla_wait(int msec)
{
	#if (defined(KWINDOWS))
		Sleep(msec);
	#elif (defined(KPOSIX))
		usleep(msec * 1000);
	#endif
}

// level1

STATIC void bla_end()
{
	int i, j;
	for (i = 0; i < bla_TABLESIZ; i++) {
		bla_Window *w = bla_table_w[i];
		if (w == 0) continue;
		bla_flushAll(w);
	}
	for (;;) {
		for (i = 0; i < bla_TABLESIZ; i++) {
			bla_Window *w = bla_table_w[i];
			if (w == 0) continue;
			if (w->phase == 2)
				bla_closeWin(w);
		}
		j = 0;
		for (i = 0; i < bla_TABLESIZ; i++) {
			bla_Window *w = bla_table_w[i];
			if (w == 0) continue;
			j++;
		}
		if (j == 0) break;
		bla_wait(128);
	}
	bla_exit(0);
}

STATIC void bla_leapFlushAll(bla_Window *w, unsigned int t)
{
	if (t == 0 || (double) (clock() - w->lastFlush) * (1000.0 / (double) CLOCKS_PER_SEC) >= (double) t)
		bla_flushAll(w);
}

STATIC int bla_inkey(bla_Window *w)
{
	int i;
	if (w->kbr == w->kbw) return 0;
	i = w->keybuf[w->kbr];
	w->kbr = (w->kbr + 1) & (bla_KEYBUFSIZ - 1);
	return i;
}

STATIC int bla_inkey0(bla_Window *w)
{
	if (w->kbr == w->kbw) return 0;
	return w->keybuf[w->kbr];
}

static unsigned char fontdata[] = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x00, 0x00, 0x10, 0x10, 0x00, 0x00,
	0x28, 0x28, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x44, 0x44, 0x44, 0xfe, 0x44, 0x44, 0x44, 0x44, 0x44, 0xfe, 0x44, 0x44, 0x44, 0x00, 0x00,
	0x10, 0x3a, 0x56, 0x92, 0x92, 0x90, 0x50, 0x38, 0x14, 0x12, 0x92, 0x92, 0xd4, 0xb8, 0x10, 0x10,
	0x62, 0x92, 0x94, 0x94, 0x68, 0x08, 0x10, 0x10, 0x20, 0x2c, 0x52, 0x52, 0x92, 0x8c, 0x00, 0x00,
	0x00, 0x70, 0x88, 0x88, 0x88, 0x90, 0x60, 0x47, 0xa2, 0x92, 0x8a, 0x84, 0x46, 0x39, 0x00, 0x00,
	0x04, 0x08, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x02, 0x04, 0x08, 0x08, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x08, 0x08, 0x04, 0x02, 0x00,
	0x80, 0x40, 0x20, 0x20, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x20, 0x20, 0x40, 0x80, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x92, 0x54, 0x38, 0x54, 0x92, 0x10, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 0x10, 0xfe, 0x10, 0x10, 0x10, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x08, 0x08, 0x10,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00,
	0x02, 0x02, 0x04, 0x04, 0x08, 0x08, 0x08, 0x10, 0x10, 0x20, 0x20, 0x40, 0x40, 0x40, 0x80, 0x80,
	0x00, 0x18, 0x24, 0x24, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x24, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x08, 0x18, 0x28, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00,
	0x00, 0x18, 0x24, 0x42, 0x42, 0x02, 0x04, 0x08, 0x10, 0x20, 0x20, 0x40, 0x40, 0x7e, 0x00, 0x00,
	0x00, 0x18, 0x24, 0x42, 0x02, 0x02, 0x04, 0x18, 0x04, 0x02, 0x02, 0x42, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x0c, 0x0c, 0x0c, 0x14, 0x14, 0x14, 0x24, 0x24, 0x44, 0x7e, 0x04, 0x04, 0x1e, 0x00, 0x00,
	0x00, 0x7c, 0x40, 0x40, 0x40, 0x58, 0x64, 0x02, 0x02, 0x02, 0x02, 0x42, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x18, 0x24, 0x42, 0x40, 0x58, 0x64, 0x42, 0x42, 0x42, 0x42, 0x42, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x7e, 0x42, 0x42, 0x04, 0x04, 0x08, 0x08, 0x08, 0x10, 0x10, 0x10, 0x10, 0x38, 0x00, 0x00,
	0x00, 0x18, 0x24, 0x42, 0x42, 0x42, 0x24, 0x18, 0x24, 0x42, 0x42, 0x42, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x18, 0x24, 0x42, 0x42, 0x42, 0x42, 0x42, 0x26, 0x1a, 0x02, 0x42, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x08, 0x08, 0x10,
	0x00, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x00,
	0x00, 0x38, 0x44, 0x82, 0x82, 0x82, 0x04, 0x08, 0x10, 0x10, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00,
	0x00, 0x38, 0x44, 0x82, 0x9a, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0x9c, 0x80, 0x46, 0x38, 0x00, 0x00,
	0x00, 0x18, 0x18, 0x18, 0x18, 0x24, 0x24, 0x24, 0x24, 0x7e, 0x42, 0x42, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0xf0, 0x48, 0x44, 0x44, 0x44, 0x48, 0x78, 0x44, 0x42, 0x42, 0x42, 0x44, 0xf8, 0x00, 0x00,
	0x00, 0x3a, 0x46, 0x42, 0x82, 0x80, 0x80, 0x80, 0x80, 0x80, 0x82, 0x42, 0x44, 0x38, 0x00, 0x00,
	0x00, 0xf8, 0x44, 0x44, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x44, 0x44, 0xf8, 0x00, 0x00,
	0x00, 0xfe, 0x42, 0x42, 0x40, 0x40, 0x44, 0x7c, 0x44, 0x40, 0x40, 0x42, 0x42, 0xfe, 0x00, 0x00,
	0x00, 0xfe, 0x42, 0x42, 0x40, 0x40, 0x44, 0x7c, 0x44, 0x44, 0x40, 0x40, 0x40, 0xf0, 0x00, 0x00,
	0x00, 0x3a, 0x46, 0x42, 0x82, 0x80, 0x80, 0x9e, 0x82, 0x82, 0x82, 0x42, 0x46, 0x38, 0x00, 0x00,
	0x00, 0xe7, 0x42, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0x7c, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x00, 0x00,
	0x00, 0x1f, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x84, 0x48, 0x30, 0x00,
	0x00, 0xe7, 0x42, 0x44, 0x48, 0x50, 0x50, 0x60, 0x50, 0x50, 0x48, 0x44, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0xf0, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x42, 0x42, 0xfe, 0x00, 0x00,
	0x00, 0xc3, 0x42, 0x66, 0x66, 0x66, 0x5a, 0x5a, 0x5a, 0x42, 0x42, 0x42, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0xc7, 0x42, 0x62, 0x62, 0x52, 0x52, 0x52, 0x4a, 0x4a, 0x4a, 0x46, 0x46, 0xe2, 0x00, 0x00,
	0x00, 0x38, 0x44, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x44, 0x38, 0x00, 0x00,
	0x00, 0xf8, 0x44, 0x42, 0x42, 0x42, 0x44, 0x78, 0x40, 0x40, 0x40, 0x40, 0x40, 0xf0, 0x00, 0x00,
	0x00, 0x38, 0x44, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x92, 0x8a, 0x44, 0x3a, 0x00, 0x00,
	0x00, 0xfc, 0x42, 0x42, 0x42, 0x42, 0x7c, 0x44, 0x42, 0x42, 0x42, 0x42, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0x3a, 0x46, 0x82, 0x82, 0x80, 0x40, 0x38, 0x04, 0x02, 0x82, 0x82, 0xc4, 0xb8, 0x00, 0x00,
	0x00, 0xfe, 0x92, 0x92, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x00, 0x00,
	0x00, 0xe7, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x24, 0x3c, 0x00, 0x00,
	0x00, 0xe7, 0x42, 0x42, 0x42, 0x42, 0x24, 0x24, 0x24, 0x24, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00,
	0x00, 0xe7, 0x42, 0x42, 0x42, 0x5a, 0x5a, 0x5a, 0x5a, 0x24, 0x24, 0x24, 0x24, 0x24, 0x00, 0x00,
	0x00, 0xe7, 0x42, 0x42, 0x24, 0x24, 0x24, 0x18, 0x24, 0x24, 0x24, 0x42, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0xee, 0x44, 0x44, 0x44, 0x28, 0x28, 0x28, 0x10, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x00, 0x00,
	0x00, 0xfe, 0x84, 0x84, 0x08, 0x08, 0x10, 0x10, 0x20, 0x20, 0x40, 0x42, 0x82, 0xfe, 0x00, 0x00,
	0x00, 0x3e, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x3e, 0x00,
	0x80, 0x80, 0x40, 0x40, 0x20, 0x20, 0x20, 0x10, 0x10, 0x08, 0x08, 0x04, 0x04, 0x04, 0x02, 0x02,
	0x00, 0x7c, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x7c, 0x00,
	0x00, 0x10, 0x28, 0x44, 0x82, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00,
	0x10, 0x08, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x08, 0x04, 0x3c, 0x44, 0x84, 0x84, 0x8c, 0x76, 0x00, 0x00,
	0xc0, 0x40, 0x40, 0x40, 0x40, 0x58, 0x64, 0x42, 0x42, 0x42, 0x42, 0x42, 0x64, 0x58, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x4c, 0x84, 0x84, 0x80, 0x80, 0x82, 0x44, 0x38, 0x00, 0x00,
	0x0c, 0x04, 0x04, 0x04, 0x04, 0x34, 0x4c, 0x84, 0x84, 0x84, 0x84, 0x84, 0x4c, 0x36, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x44, 0x82, 0x82, 0xfc, 0x80, 0x82, 0x42, 0x3c, 0x00, 0x00,
	0x0e, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x4c, 0x84, 0x84, 0x84, 0x84, 0x4c, 0x34, 0x04, 0x04, 0x78,
	0xc0, 0x40, 0x40, 0x40, 0x40, 0x58, 0x64, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0xe3, 0x00, 0x00,
	0x00, 0x10, 0x10, 0x00, 0x00, 0x30, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38, 0x00, 0x00,
	0x00, 0x04, 0x04, 0x00, 0x00, 0x0c, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x08, 0x08, 0x30,
	0xc0, 0x40, 0x40, 0x40, 0x40, 0x4e, 0x44, 0x48, 0x50, 0x60, 0x50, 0x48, 0x44, 0xe6, 0x00, 0x00,
	0x30, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xf6, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0xdb, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xd8, 0x64, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0xe3, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x44, 0x82, 0x82, 0x82, 0x82, 0x82, 0x44, 0x38, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xd8, 0x64, 0x42, 0x42, 0x42, 0x42, 0x42, 0x64, 0x58, 0x40, 0xe0,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x34, 0x4c, 0x84, 0x84, 0x84, 0x84, 0x84, 0x4c, 0x34, 0x04, 0x0e,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xdc, 0x62, 0x42, 0x40, 0x40, 0x40, 0x40, 0x40, 0xe0, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x7a, 0x86, 0x82, 0xc0, 0x38, 0x06, 0x82, 0xc2, 0xbc, 0x00, 0x00,
	0x00, 0x00, 0x10, 0x10, 0x10, 0x7c, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x0e, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xc6, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3b, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xe7, 0x42, 0x42, 0x42, 0x24, 0x24, 0x24, 0x18, 0x18, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xe7, 0x42, 0x42, 0x5a, 0x5a, 0x5a, 0x24, 0x24, 0x24, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xc6, 0x44, 0x28, 0x28, 0x10, 0x28, 0x28, 0x44, 0xc6, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xe7, 0x42, 0x42, 0x24, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x60,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x82, 0x84, 0x08, 0x10, 0x20, 0x42, 0x82, 0xfe, 0x00, 0x00,
	0x00, 0x06, 0x08, 0x10, 0x10, 0x10, 0x10, 0x60, 0x10, 0x10, 0x10, 0x10, 0x08, 0x06, 0x00, 0x00,
	0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
	0x00, 0x60, 0x10, 0x08, 0x08, 0x08, 0x08, 0x06, 0x08, 0x08, 0x08, 0x08, 0x10, 0x60, 0x00, 0x00,
	0x00, 0x72, 0x8c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x10, 0x28, 0x44, 0x82, 0xfe, 0x82, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00
};

STATIC void bla_setPixEx(bla_Window *w, int x, int y, int c)
{
	if (c >= 0 && 0 <= x && x < w->xsiz && 0 <= y && y < w->ysiz) {
		if (w->mode == bla_MODE_SET) w->buf[y * w->xsiz + x] =  c;
		if (w->mode == bla_MODE_OR)  w->buf[y * w->xsiz + x] |= c;
		if (w->mode == bla_MODE_AND) w->buf[y * w->xsiz + x] &= c;
		if (w->mode == bla_MODE_XOR) w->buf[y * w->xsiz + x] ^= c;
	}
}

STATIC void bla_fillRect(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	int i, j, *b = w->buf + x0 + y0 * w->xsiz;
	for (j = 0; j < sy; j++) {
		for (i = 0; i < sx; i++)
			b[i] = c;
		b += w->xsiz;
	}
}

STATIC void bla_fillRectEx(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	int i, j;
	for (j = 0; j < sy; j++) {
		for (i = 0; i < sx; i++) {
			bla_setPixEx(w, x0 + i, y0 + j, c);
		}
	}
}

STATIC void bla_drawRect(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	if (sx <= 1 || sy <= 1)
		bla_fillRect(w, sx, sy, x0, y0, c);
	else {
		bla_fillRect(w, sx, 1,      x0,          y0,          c);
		bla_fillRect(w, sx, 1,      x0,          y0 + sy - 1, c);
		bla_fillRect(w, 1,  sy - 2, x0,          y0 + 1,      c);
		bla_fillRect(w, 1,  sy - 2, x0 + sx - 1, y0 + 1,      c);
	}
}

STATIC void bla_drawRectEx(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	if (sx <= 1 || sy <= 1)
		bla_fillRectEx(w, sx, sy, x0, y0, c);
	else {
		bla_fillRectEx(w, sx, 1,      x0,          y0,          c);
		bla_fillRectEx(w, sx, 1,      x0,          y0 + sy - 1, c);
		bla_fillRectEx(w, 1,  sy - 2, x0,          y0 + 1,      c);
		bla_fillRectEx(w, 1,  sy - 2, x0 + sx - 1, y0 + 1,      c);
	}
}

STATIC void bla_drawStr(bla_Window *w, int x, int y, int c, int b, const char *s)
{
	int i, j, k, ch, pt;
	for (i = 0; s[i] != '\0'; i++) {
		ch = s[i];
		if (ch < ' ' || ch > 0x7f) ch = ' ';
		ch = (ch - ' ') * 16;
		for (j = 0; j < 16; j++) {
			pt = fontdata[ch + j];
			for (k = 0; k < 8; k++) {
				if ((pt & 0x80) != 0) {
					bla_setPix(w, x + k, y + j, c);
				} else {
					bla_setPix(w, x + k, y + j, b);
				}
				pt <<= 1;
			}
		}
		x += 8;
	}
}

STATIC void bla_drawStrEx(bla_Window *w, int x, int y, int c, int b, const char *s)
{
	int i, j, k, ch, pt;
	for (i = 0; s[i] != '\0'; i++) {
		ch = s[i];
		if (ch < ' ' || ch > 0x7f) ch = ' ';
		ch = (ch - ' ') * 16;
		for (j = 0; j < 16; j++) {
			pt = fontdata[ch + j];
			for (k = 0; k < 8; k++) {
				if ((pt & 0x80) != 0) {
					bla_setPixEx(w, x + k, y + j, c);
				} else {
					bla_setPixEx(w, x + k, y + j, b);
				}
				pt <<= 1;
			}
		}
		x += 8;
	}
}

STATIC void bla_drawLine(bla_Window *w, int x0, int y0, int x1, int y1, int c)
{
	int x, y, dx, dy, sx, sy, err, e2;
	dx = x1 - x0;
	dy = y1 - y0;
	sx = sy = 1;
	if (dx < 0) { dx *= -1; sx = -1; }
	if (dy < 0) { dy *= -1; sy = -1; }
	err = dx - dy;
	x = x0;
	y = y0;
	for (;;) {
		bla_setPix(w, x, y, c);
		if (x == x1 && y == y1) break;
		e2 = err * 2;
		if (e2 > - dy) {
			err -= dy;
			x += sx;
		}
		if (e2 <   dx) {
			err += dx;
			y += sy;
		}
	}
}

STATIC void bla_drawLineEx(bla_Window *w, int x0, int y0, int x1, int y1, int c)
{
	int x, y, dx, dy, sx, sy, err, e2;
	dx = x1 - x0;
	dy = y1 - y0;
	sx = sy = 1;
	if (dx < 0) { dx *= -1; sx = -1; }
	if (dy < 0) { dy *= -1; sy = -1; }
	err = dx - dy;
	x = x0;
	y = y0;
	for (;;) {
		bla_setPixEx(w, x, y, c);
		if (x == x1 && y == y1) break;
		e2 = err * 2;
		if (e2 > - dy) {
			err -= dy;
			x += sx;
		}
		if (e2 <   dx) {
			err += dx;
			y += sy;
		}
	}
}

STATIC void bla_fillOval(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	double dcx, dcy, dcxy, dtx, dty;
	int x, y;
	dcx = 0.5 * (sx - 1);
	dcy = 0.5 * (sy - 1);
	dcxy = (dcx + 0.5) * (dcy + 0.5) - 0.1;
	dcxy *= dcxy;
	for (y = 0; y < sy; y++) {
		dty = (y - dcy) * dcx;
		for (x = 0; x < sx; x++) {
			dtx = (x - dcx) * dcy;
			if (dtx * dtx + dty * dty > dcxy) continue;
				bla_setPix(w, x + x0, y + y0, c);
		}
	}
}

STATIC void bla_fillOvalEx(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	double dcx, dcy, dcxy, dtx, dty;
	int x, y;
	dcx = 0.5 * (sx - 1);
	dcy = 0.5 * (sy - 1);
	dcxy = (dcx + 0.5) * (dcy + 0.5) - 0.1;
	dcxy *= dcxy;
	for (y = 0; y < sy; y++) {
		dty = (y - dcy) * dcx;
		for (x = 0; x < sx; x++) {
			dtx = (x - dcx) * dcy;
			if (dtx * dtx + dty * dty > dcxy) continue;
				bla_setPixEx(w, x + x0, y + y0, c);
		}
	}
}

#define DRAWOVALPARAM	1

STATIC void bla_drawOvalEx(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	double dcx, dcy, dcxy, dtx, dty, dcx1, dcy1, dcxy1, dtx1, dty1;
	int x, y;
	dcx = 0.5 * (sx - 1);
	dcy = 0.5 * (sy - 1);
	dcxy = (dcx + 0.5) * (dcy + 0.5) - 0.1;
	dcxy *= dcxy;
	dcx1 = 0.5 * (sx - (1 + DRAWOVALPARAM * 2));
	dcy1 = 0.5 * (sy - (1 + DRAWOVALPARAM * 2));
	dcxy1 = (dcx1 + 0.5) * (dcy1 + 0.5) - 0.1;
	dcxy1 *= dcxy1;
	for (y = 0; y < sy; y++) {
		dty  = (y - dcy) * dcx;
		dty1 = (y - dcy) * dcx1;
		for (x = 0; x < sx; x++) {
			dtx = (x - dcx) * dcy;
			dtx1 = (x - dcx) * dcy1;
			if (dtx * dtx + dty * dty > dcxy) continue;
			if (DRAWOVALPARAM <= x && x < sx - DRAWOVALPARAM && DRAWOVALPARAM <= y && y < sy - DRAWOVALPARAM) {
				if (dtx1 * dtx1 + dty1 * dty1 < dcxy1) continue;
			}
			bla_setPixEx(w, x + x0, y + y0, c);
		}
	}
}

typedef struct bla_Point_ {
	int x, y;
} bla_Point;

STATIC void bla_fillEx(bla_Window *w, int x, int y, int c)
{
	int b, sp, sx = w->xsiz, sy = w->ysiz, u, v, *q = w->buf;
	bla_Point *p;
	if (x < 0 || x >= sx || y < 0 || y >= sy || c < 0) return;
	b = q[x + y * sx];
	if (b == c) return;
	p = (bla_Point *) malloc(sx * sy * sizeof (bla_Point));
	sp = 0; p[sp].x = x; p[sp].y = y; q[x + y * sx] = c;
	do {
		x = p[sp].x;
		y = p[sp].y;
		sp--;
		u = x;     v = y + 1; if (v < sy && q[u + v * sx] == b) { sp++; p[sp].x = u; p[sp].y = v; q[u + v * sx] = c; }
		u = x;     v = y - 1; if (v >= 0 && q[u + v * sx] == b) { sp++; p[sp].x = u; p[sp].y = v; q[u + v * sx] = c; }
		u = x + 1; v = y;     if (u < sx && q[u + v * sx] == b) { sp++; p[sp].x = u; p[sp].y = v; q[u + v * sx] = c; }
		u = x - 1; v = y;     if (u >= 0 && q[u + v * sx] == b) { sp++; p[sp].x = u; p[sp].y = v; q[u + v * sx] = c; }
	} while (sp >= 0);
	free(p);
}

STATIC void bla_waitEx(int msec)
{
	do {
		int i, j = 0;
		for (i = 0; i < bla_TABLESIZ; i++) {
			bla_Window *w = bla_table_w[i];
			if (w == 0) continue;
			if (w->phase == 1) j++;
		}
		if (j == 0) bla_end();
		if (msec > 0) {
			i = msec;
			if (i >= 256)
				i = 128;
			bla_wait(i);
			msec -= i;
		}
	} while (msec > 0);
}

typedef union {
  uint32_t w;
  uint16_t h[2];
  uint8_t  b[4];
} eword_t;

static uint32_t write_le32(uint32_t val)
{
  eword_t ew;
  ew.b[3] = (val >> 24) & 0xff;
  ew.b[2] = (val >> 16) & 0xff;
  ew.b[1] = (val >>  8) & 0xff;
  ew.b[0] = (val      ) & 0xff;
  return ew.w;
}

static uint16_t write_le16(uint16_t val)
{
  eword_t ew;
  ew.b[1] = (val >> 8) & 0xff;
  ew.b[0] = (val     ) & 0xff;
  return ew.h[0];
}

struct BMP_fileheader {
  uint8_t type[2];
  uint32_t size;
  uint16_t reserve1;
  uint16_t reserve2;
  uint32_t offset;
} __attribute__((packed));
#define BMP_FILEHEADER_SIZE 14

struct BMP_infoheader {
  uint32_t ihdrsize;
  uint32_t width;
  uint32_t height;
  uint16_t planes;
  uint16_t bits;
  uint32_t compress;
  uint32_t imagesize;
  uint32_t xpix;
  uint32_t ypix;
  uint32_t colors;
  uint32_t impcolors;
} __attribute__((packed));
#define BMP_INFOHEADER_SIZE 40

#define BMP_BYTEPERPIX 3

STATIC int bla_outBitmapToFile(bla_Window *w, const char *filename,
			       int width, int height, int x0, int y0)
{
  FILE *fp;
  struct BMP_fileheader fhdr;
  struct BMP_infoheader ihdr;

  fp = fopen(filename, "wb");
  if (!fp) return -1;

  if (width  <= 0) width  = w->xsiz;
  if (height <= 0) height = w->ysiz;

  memset(&fhdr, 0, sizeof(fhdr));
  fhdr.type[0] = 'B';
  fhdr.type[1] = 'M';
  fhdr.size   = write_le32(BMP_FILEHEADER_SIZE + BMP_INFOHEADER_SIZE + width * height * BMP_BYTEPERPIX);
  fhdr.offset = write_le32(BMP_FILEHEADER_SIZE + BMP_INFOHEADER_SIZE);
  fwrite(&fhdr, BMP_FILEHEADER_SIZE, 1, fp);

  memset(&ihdr, 0, sizeof(ihdr));
  ihdr.ihdrsize = write_le32(BMP_INFOHEADER_SIZE);
  ihdr.width = write_le32(width);
  ihdr.height = write_le32(height);
  ihdr.planes = write_le16(1);
  ihdr.bits = write_le16(BMP_BYTEPERPIX * 8);
  ihdr.compress = write_le32(0);
  ihdr.imagesize = write_le32(width * height * BMP_BYTEPERPIX);
  ihdr.xpix = write_le32(2925);
  ihdr.ypix = write_le32(2925);
  ihdr.colors = write_le32(0);
  ihdr.impcolors = write_le32(0);
  fwrite(&ihdr, BMP_INFOHEADER_SIZE, 1, fp);

  {
    int x, y;
    for (y = 0; y < height; y++) {
      for (x = 0; x < width; x++) {
	unsigned int r, b, g, c;
	if ((x0 + x < 0) || (x0 + x > w->xsiz - 1) ||
	    (y0 + y < 0) || (y0 + y > w->ysiz - 1))
	  c = 0;
	else
	  c = w->buf[(y0 + (height - y - 1)) * w->xsiz + (x0 + x)];
	r = (c >> 16) & 0xff;
	g = (c >>  8) & 0xff;
	b = (c >>  0) & 0xff;
	fwrite(&b, 1, 1, fp);
	fwrite(&g, 1, 1, fp);
	fwrite(&r, 1, 1, fp);
      }
    }
  }

  fclose(fp);

  return 0;
}

